<template>
  <v-container
    class="app-container"
  > 
    <!-- OPTIONS INPUT COMPONENT -->
    <v-row class="input-options">
      <v-col
        cols="12"
        md="3"
      >
        <v-text-field
          class="search-input"
          v-model="search"
          clearable
          solo
          hide-details
          append-icon="mdi-magnify"
          label="Busque por nomes ou emails"
        ></v-text-field>
      </v-col>
      <v-col
        cols="12"
        md="7"
      >
        <div class="filters-section">
          <span>
            Filtros:
          </span>
          <v-autocomplete
            filled
            hide-details
            solo
            dense
            class="filter-block"
            :items="propertiesOptions"
            placeholder="Todos"
            v-model="search"
          ></v-autocomplete>
        </div>
      </v-col>
      <v-col
        cols="12"
        md="2"
      >
        <v-btn 
          @click.stop="dialog = true"
          class="btn-novo-aluno" 
          color="custom-peach"
          
        >
          <v-icon color="white">
            mdi-account-plus
          </v-icon>
          <span>Novo Aluno</span>
        </v-btn>
      </v-col>
    </v-row>
     <!-- END OF OPTIONS INPUT COMPONENT -->

     <!-- USER RENDER LIST COMPONENT -->
    <v-data-iterator 
        class="row" 
        :items="users" 
        :search="search"
        disable-pagination
        hide-default-footer
        loading
        loading-text="Carregando usuários..."
        no-results-text="Não há usuários com os critérios de busca utilizados"
      >
        <template v-slot:default="props">
          <v-col 
            cols="12" 
            sm="6" 
            md="4" 
            lg="3" 
            v-for="(user,index) in props.items" :key="index"
          >
            <v-hover>
              <template v-slot:default="{ hover }">
                <v-card 
                  class="user-card transition-swing"
                  :class="`elevation-${hover ? 16 : 2}`"
                >
                  <v-container fluid>
                    <div class="row card-header">
                      <v-avatar right class="mt-2 ml-1 align-self-center col-2">
                        <img v-bind:src="user.picture.thumbnail"/>
                      </v-avatar>
                      <div class="card-user-title-subtitle col-9">
                        <v-card-title>
                          {{ user.name.first + ' ' + user.name.last }}
                        </v-card-title>
                        <v-card-subtitle>
                          Última avaliação: {{ moment(user.registered.date).format('L') }}
                        </v-card-subtitle>
                      </div>
                    </div>
                    <v-divider>
                    </v-divider>
                    <div class="row card-user-details">
                      <div class="col-8">
                        <p>{{ user.email }}</p>
                        <p>{{ user.dob.age }} anos {{ user.phone }}</p>
                      </div>
                      <v-card-actions class="card-user-actions col-4">
                        <v-btn small fab class="elevation-2">
                          <v-icon color="deep-purple darken-3">
                            mdi-pencil
                          </v-icon>
                        </v-btn>
                        <v-btn
                          plain
                          icon
                        >
                          <v-icon color="deep-purple darken-3">
                            mdi-dots-horizontal
                          </v-icon>
                        </v-btn>
                      </v-card-actions>
                    </div>
                  </v-container>
                </v-card>
              </template>
            </v-hover>
          </v-col>
        </template>
      </v-data-iterator>
      <!-- END OF USER RENDER LIST COMPONENT -->

      <!-- ADD NEW USER DIALOG -->
      <v-row>
          <v-dialog
            v-model="dialog"
            persistent
            light
            width="50vw" 
            :fullscreen="$vuetify.breakpoint.xsOnly"
          >
            <v-card>
              <v-card-title class="deep-purple darken-4">
                <span class="headline">Cadastrar Aluno</span>
                <v-btn class="close-icon" @click="dialog = false">
                  <v-icon>
                    mdi-close
                  </v-icon>
                </v-btn>
              </v-card-title>
              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col
                      cols="12"
                    >
                      <v-text-field
                        v-model="createdUser.name.first"
                        label="Nome "
                      ></v-text-field>
                      <v-text-field
                        v-model="createdUser.email"
                        label="E-mail"
                      ></v-text-field>
                      <v-text-field
                        v-model="createdUser.dob.age"
                        label="Idade"
                      ></v-text-field>
                      <v-text-field
                        v-model="createdUser.phone"
                        label="Telefone"
                      ></v-text-field>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>
              <v-card-actions>

                <v-btn
                  class="cancel-button"
                  color="deep-purple darken-1"
                  text
                  @click="dialog = false"
                >
                  Cancelar
                </v-btn>
                <v-spacer></v-spacer>
                <v-btn
                  class="confirm-button"
                  color="white"
                  raised
                  text
                  @click.prevent="onSubmit"
                >
                  SALVAR
                </v-btn>
              </v-card-actions>
          </v-card>
        </v-dialog>
    </v-row>
    <!-- END OF ADD NEW USER DIALOG -->

  </v-container>
</template>

<script>

  export default {
    name: 'UserList',
    props: {
      users : {
        type: Array
      },
      newuser : {
        type: Object,
        required: true
      }

    },

    data: () => ({
      dialog: false,
      search: '',
      page: 1,
      sortBy: 'name',
      sortDesc: false

    }),

    computed: {
      propertiesOptions: function() {
        const nationalities = [];
        const gender = [];
        for (let i=0; i<this.users.length;i++) {
          gender.push(this.users[i].gender)
          nationalities.push(this.users[i].nat)
        }
        const whole = gender.concat(nationalities)
        return whole
      },
      createdUser: {
        get() { return this.newuser },
        set(createdUser) { this.$emit('added-user', createdUser) }
      }
    },
    methods: {
      onSubmit() {
        this.$emit('added-user', this.createdUser)
        this.dialog = false
        this.resetForm()
      },
      resetForm() {
        this.createdUser.name.first = '';
        this.createdUser.dob.age = '';
        this.createdUser.email = '';
        this.createdUser.phone = '';

      }
    },
  }
</script>

<style scoped>
  .app-container {
    max-width: 90vw;
    padding-top: 3rem;
  }

  .v-sheet.user-card {
    min-height: 192px;
    max-height: 240px;
    overflow: hidden;
  }

  .v-card__actions {
    padding-left: 0;
    padding-right: 0;
    justify-content: center;
    margin-left: auto;
  }

  .v-card__actions.card-user-actions .v-btn {
    background-color: white;
  }

  .card-user-details {
    padding-left: 1rem;
    padding-right: 1rem;
    padding-top: 1rem;
  }

  .card-user-details p {
    margin-bottom: 0;
    font-size: 14px;
    color: gray;
    text-overflow: ellipsis;
    white-space: nowrap;
    overflow: hidden;
  }

  .v-card__subtitle {
    padding-bottom: 0;
    padding-left: 0;
    padding-right: 0;
    font-size: .875rem;
    color: #757575;
  }

  .v-card__title {
    padding-left: 0;
    padding-right: 0;
    font-weight: 600;
    padding-bottom: 0;
    color: #424242;
  }

  .v-card__title + .v-card__subtitle {
    padding-top: .75rem;
  }

  .card-header {
    justify-content: center;
    padding-bottom: 1rem;
  }

  .input-options .search-input {
    background-color: pink;
  }

  .input-options .v-text-field {
    max-width: 20rem;
  }

  .filter-block {
    max-width: 15rem;
  }

  .input-options {
    justify-content: space-between;
    align-items: center;
  }

  .filters-section {
    margin-left: auto;
    display: flex;
    align-items: center;
    justify-content: flex-end;
  }

  .filters-section .v-input {
    padding-left: 1rem;
  }

  .btn-novo-aluno span, .headline {
    color: white;
  }

  .v-dialog .v-card__title {
    background: indigo;
  }

  .v-dialog .v-card__title .v-btn {
    background: transparent;
    box-shadow: none;
    color: white;
    margin-left: auto;
  }

  .confirm-button {
    background: orangered;
    padding-left: 2rem;
    padding-right: 2rem;
  }

  .cancel-button {
    font-weight: bold;
    letter-spacing: 0;
  }

  .v-card__actions > .v-btn.v-btn {
    padding: 0 16px;
}

.app-dialog {
  max-width: 10vw;
}

@media (min-width: 768px) and (max-width:1023px) { 
  .filters-section {
    justify-content: flex-start;
  }
}
</style>

